Index: /pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia-videodev/v4l2_dev.c
===================================================================
--- /pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia-videodev/v4l2_dev.c	(revision 3446)
+++ /pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia-videodev/v4l2_dev.c	(revision 3447)
@@ -91,5 +91,5 @@
 typedef struct vid4lin_stream
 {
-    pjmedia_vid_stream	 	 base;		/**< Base stream	*/
+    pjmedia_vid_dev_stream	 base;		/**< Base stream	*/
     pjmedia_vid_param	 	 param;		/**< Settings		*/
     pj_pool_t           	*pool;		/**< Memory pool.	*/
@@ -132,19 +132,19 @@
 					         const pjmedia_vid_cb *cb,
 					         void *user_data,
-					         pjmedia_vid_stream **p_strm);
-
-static pj_status_t vid4lin_stream_get_param(pjmedia_vid_stream *strm,
+					         pjmedia_vid_dev_stream **p);
+
+static pj_status_t vid4lin_stream_get_param(pjmedia_vid_dev_stream *strm,
 					    pjmedia_vid_param *param);
-static pj_status_t vid4lin_stream_get_cap(pjmedia_vid_stream *strm,
+static pj_status_t vid4lin_stream_get_cap(pjmedia_vid_dev_stream *strm,
 				          pjmedia_vid_dev_cap cap,
 				          void *value);
-static pj_status_t vid4lin_stream_set_cap(pjmedia_vid_stream *strm,
+static pj_status_t vid4lin_stream_set_cap(pjmedia_vid_dev_stream *strm,
 				          pjmedia_vid_dev_cap cap,
 				          const void *value);
-static pj_status_t vid4lin_stream_get_frame(pjmedia_vid_stream *strm,
+static pj_status_t vid4lin_stream_get_frame(pjmedia_vid_dev_stream *strm,
                                             pjmedia_frame *frame);
-static pj_status_t vid4lin_stream_start(pjmedia_vid_stream *strm);
-static pj_status_t vid4lin_stream_stop(pjmedia_vid_stream *strm);
-static pj_status_t vid4lin_stream_destroy(pjmedia_vid_stream *strm);
+static pj_status_t vid4lin_stream_start(pjmedia_vid_dev_stream *strm);
+static pj_status_t vid4lin_stream_stop(pjmedia_vid_dev_stream *strm);
+static pj_status_t vid4lin_stream_destroy(pjmedia_vid_dev_stream *strm);
 
 /* Operations */
@@ -159,5 +159,5 @@
 };
 
-static pjmedia_vid_stream_op stream_op =
+static pjmedia_vid_dev_stream_op stream_op =
 {
     &vid4lin_stream_get_param,
@@ -390,6 +390,4 @@
     param->flags = PJMEDIA_VID_DEV_CAP_FORMAT;
     param->clock_rate = DEFAULT_CLOCK_RATE;
-    param->frame_rate.num = DEFAULT_FPS;
-    param->frame_rate.denum = 1;
     pjmedia_format_copy(&param->fmt, &cf->dev_info[index].info.fmt[0]);
 
@@ -516,8 +514,8 @@
 /* API: create stream */
 static pj_status_t vid4lin_factory_create_stream(pjmedia_vid_dev_factory *f,
-					      const pjmedia_vid_param *param,
-					      const pjmedia_vid_cb *cb,
-					      void *user_data,
-					      pjmedia_vid_stream **p_vid_strm)
+				      const pjmedia_vid_param *param,
+				      const pjmedia_vid_cb *cb,
+				      void *user_data,
+				      pjmedia_vid_dev_stream **p_vid_strm)
 {
     vid4lin_factory *cf = (vid4lin_factory*)f;
@@ -596,6 +594,6 @@
 
 /* API: Get stream info. */
-static pj_status_t vid4lin_stream_get_param(pjmedia_vid_stream *s,
-					 pjmedia_vid_param *pi)
+static pj_status_t vid4lin_stream_get_param(pjmedia_vid_dev_stream *s,
+					    pjmedia_vid_param *pi)
 {
     vid4lin_stream *strm = (vid4lin_stream*)s;
@@ -609,7 +607,7 @@
 
 /* API: get capability */
-static pj_status_t vid4lin_stream_get_cap(pjmedia_vid_stream *s,
-				       pjmedia_vid_dev_cap cap,
-				       void *pval)
+static pj_status_t vid4lin_stream_get_cap(pjmedia_vid_dev_stream *s,
+                                          pjmedia_vid_dev_cap cap,
+                                          void *pval)
 {
     vid4lin_stream *strm = (vid4lin_stream*)s;
@@ -629,7 +627,7 @@
 
 /* API: set capability */
-static pj_status_t vid4lin_stream_set_cap(pjmedia_vid_stream *s,
-				       pjmedia_vid_dev_cap cap,
-				       const void *pval)
+static pj_status_t vid4lin_stream_set_cap(pjmedia_vid_dev_stream *s,
+                                          pjmedia_vid_dev_cap cap,
+                                          const void *pval)
 {
     vid4lin_stream *strm = (vid4lin_stream*)s;
@@ -693,5 +691,5 @@
 
 /* API: Get frame from stream */
-static pj_status_t vid4lin_stream_get_frame(pjmedia_vid_stream *strm,
+static pj_status_t vid4lin_stream_get_frame(pjmedia_vid_dev_stream *strm,
                                             pjmedia_frame *frame)
 {
@@ -707,5 +705,5 @@
 
 /* API: Start stream. */
-static pj_status_t vid4lin_stream_start(pjmedia_vid_stream *strm)
+static pj_status_t vid4lin_stream_start(pjmedia_vid_dev_stream *strm)
 {
     vid4lin_stream *stream = (vid4lin_stream*)strm;
@@ -755,5 +753,5 @@
 
 /* API: Stop stream. */
-static pj_status_t vid4lin_stream_stop(pjmedia_vid_stream *strm)
+static pj_status_t vid4lin_stream_stop(pjmedia_vid_dev_stream *strm)
 {
     vid4lin_stream *stream = (vid4lin_stream*)strm;
@@ -776,5 +774,5 @@
 
 /* API: Destroy stream. */
-static pj_status_t vid4lin_stream_destroy(pjmedia_vid_stream *strm)
+static pj_status_t vid4lin_stream_destroy(pjmedia_vid_dev_stream *strm)
 {
     vid4lin_stream *stream = (vid4lin_stream*)strm;